.\" Man page generated from reStructuredText.
.
.TH "KSWITCH" "1" " " "1.15.1" "MIT Kerberos"
.SH NAME
kswitch \- switch primary ticket cache
.
.nr rst2man-indent-level 0
.
.de1 rstReportMargin
\\$1 \\n[an-margin]
level \\n[rst2man-indent-level]
level margin: \\n[rst2man-indent\\n[rst2man-indent-level]]
-
\\n[rst2man-indent0]
\\n[rst2man-indent1]
\\n[rst2man-indent2]
..
.de1 INDENT
.\" .rstReportMargin pre:
. RS \\$1
. nr rst2man-indent\\n[rst2man-indent-level] \\n[an-margin]
. nr rst2man-indent-level +1
.\" .rstReportMargin post:
..
.de UNINDENT
. RE
.\" indent \\n[an-margin]
.\" old: \\n[rst2man-indent\\n[rst2man-indent-level]]
.nr rst2man-indent-level -1
.\" new: \\n[rst2man-indent\\n[rst2man-indent-level]]
.in \\n[rst2man-indent\\n[rst2man-indent-level]]u
..
.SH SYNOPSIS
.sp
\fBkswitch\fP
{\fB\-c\fP \fIcachename\fP|\fB\-p\fP \fIprincipal\fP}
.SH DESCRIPTION
.sp
kswitch makes the specified credential cache the primary cache for the
collection, if a cache collection is available.
.SH OPTIONS
.INDENT 0.0
.TP
.B \fB\-c\fP \fIcachename\fP
Directly specifies the credential cache to be made primary.
.TP
.B \fB\-p\fP \fIprincipal\fP
Causes the cache collection to be searched for a cache containing
credentials for \fIprincipal\fP\&.  If one is found, that collection is
made primary.
.UNINDENT
.SH ENVIRONMENT
.sp
kswitch uses the following environment variables:
.INDENT 0.0
.TP
.B \fBKRB5CCNAME\fP
Location of the default Kerberos 5 credentials (ticket) cache, in
the form \fItype\fP:\fIresidual\fP\&.  If no \fItype\fP prefix is present, the
\fBFILE\fP type is assumed.  The type of the default cache may
determine the availability of a cache collection; for instance, a
default cache of type \fBDIR\fP causes caches within the directory
to be present in the collection.
.UNINDENT
.SH FILES
.INDENT 0.0
.TP
.B \fB@CCNAME@\fP
Default location of Kerberos 5 credentials cache
.UNINDENT
.SH SEE ALSO
.sp
\fIkinit(1)\fP, \fIkdestroy(1)\fP, \fIklist(1)\fP), kerberos(1)
.SH AUTHOR
MIT
.SH COPYRIGHT
1985-2017, MIT
.\" Generated by docutils manpage writer.
.
